#!/usr/bin/perl -w
# Copyright 2002, Reto Stamm
#
# This file is part of Majorteach.
#
# Majorteach is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Majorteach is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Majorteach; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


use strict;
my @pegs;
my @comppegs;
my @count;
my @time;
my $wordc =0;
my $wordm =0.0001;
my $numc = 0;
my $numm = 0.0001;
my $TIMEMAX = 30;
my $BACK = 101;

my $index = 0;
foreach my $line (split /\n/,`cat ./pegs.txt`) {
  chomp $line;
  if (!($line =~ /#/)) {
    $pegs[$index] = $line;
    $line =~ tr/a-z/A-Z/;
    $comppegs[$index] = $line;
    $count[$index] = 0;
    $time[$index] = 0;
    $index++;
  }
}

$index = int(rand(@pegs-1));
tick();
while (1) {
  if (($index < $BACK) and (rand() < 0.5)) {
    print "$index = ";
    my $response = <>;
    chomp $response;
    $response =~ tr/a-z/A-Z/;
    if ($response eq $comppegs[$index]) {
      print "OK";
      $wordm ++;
      $wordc ++;
      stats();
      tock();
      tick();
      $index = int(rand(@pegs-1));
    } else {
      print "NO NO NO NO NO";
      $wordm ++;
      $wordc--;
    }
    print "\n\n";
  } else {
    print "$pegs[$index] = ";
    my $response = <>;
    chomp $response;
    if ($response eq $index) {
      print "OK";
      stats();
      tock();
      tick();
      $numm ++;
      $numc ++;
      $index = int(rand(@pegs-1));
    } else {
      print "NO NO NO NO NO";
      $numm ++;
      $numc --;
    }
    print "\n\n";
  }
}

my $start;

#start counting time
sub tick {
  print "\n\nContinue?\n\n";
  my $x =<>;
  $start = time();
}

#stop counting time, write file
sub tock {
  my $delta = time() - $start;
  print "\n$delta s\n";
  if ($delta > $TIMEMAX) {
    return;
  }
  else {
    $count[$index] ++;
    $time[$index] = $time[$index]+$delta;
    open FILE, ">./statistics.txt";
    print FILE "NUMBER   AVERAGE   TIME    COUNT\n";
    for (my $c=0; $c < @time; $c++) {
      my $avg =0;
      if ($count[$c] > 0) {
        $avg = $time[$c] / $count[$c];
      }
      print FILE "$c   $avg   $time[$c]   $count[$c]\n";
    }
    close FILE;
  }
}

sub stats{
  print "\nWords: ".int(100*$wordc/$wordm)."% Numbers ".int(100*$numc/$numm)."%\n";
}
